import { isJSONObject } from '../../../helpers/json.js';
import { unmarshalDate, unmarshalArrayOfObject, resolveOneOf } from '../../../helpers/marshalling.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
const unmarshalResource = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Resource' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    macAddress: data.mac_address,
    name: data.name,
    type: data.type
  };
};
const unmarshalSource = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Source' failed as data isn't a dictionary.`);
  }
  return {
    privateNetworkId: data.private_network_id,
    subnetId: data.subnet_id,
    zonal: data.zonal
  };
};
const unmarshalIP = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'IP' failed as data isn't a dictionary.`);
  }
  return {
    address: data.address,
    createdAt: unmarshalDate(data.created_at),
    id: data.id,
    isIpv6: data.is_ipv6,
    projectId: data.project_id,
    region: data.region,
    resource: data.resource ? unmarshalResource(data.resource) : undefined,
    source: data.source ? unmarshalSource(data.source) : undefined,
    tags: data.tags,
    updatedAt: unmarshalDate(data.updated_at),
    zone: data.zone
  };
};
const unmarshalListIPsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListIPsResponse' failed as data isn't a dictionary.`);
  }
  return {
    ips: unmarshalArrayOfObject(data.ips, unmarshalIP),
    totalCount: data.total_count
  };
};
const marshalSource = (request, defaults) => ({
  ...resolveOneOf([{
    param: 'zonal',
    value: request.zonal
  }, {
    param: 'private_network_id',
    value: request.privateNetworkId
  }, {
    param: 'subnet_id',
    value: request.subnetId
  }])
});
const marshalBookIPRequest = (request, defaults) => ({
  address: request.address,
  is_ipv6: request.isIpv6,
  project_id: request.projectId ?? defaults.defaultProjectId,
  source: request.source ? marshalSource(request.source) : undefined,
  tags: request.tags
});
const marshalUpdateIPRequest = (request, defaults) => ({
  tags: request.tags
});

export { marshalBookIPRequest, marshalUpdateIPRequest, unmarshalIP, unmarshalListIPsResponse };
