import { API as API$1 } from '../../../scw/api.js';
import { urlParams, validatePathParam } from '../../../helpers/marshalling.js';
import { enrichForPagination } from '../../../scw/fetch/resource-paginator.js';
import { unmarshalListImagesResponse, unmarshalGetImageResponse, unmarshalListVersionsResponse, unmarshalGetVersionResponse } from './marshalling.gen.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
/** Marketplace API. */
class API extends API$1 {
  pageOfListImages = (() => {
    var _this = this;
    return function (request) {
      if (request === void 0) {
        request = {};
      }
      return _this.client.fetch({
        method: 'GET',
        path: `/marketplace/v1/images`,
        urlParams: urlParams(['page', request.page], ['per_page', request.perPage ?? _this.client.settings.defaultPageSize])
      }, unmarshalListImagesResponse);
    };
  })();

  /**
   * List marketplace images.
   *
   * @param request - The request {@link ListImagesRequest}
   * @returns A Promise of ListImagesResponse
   */
  listImages = (() => {
    var _this2 = this;
    return function (request) {
      if (request === void 0) {
        request = {};
      }
      return enrichForPagination('images', _this2.pageOfListImages, request);
    };
  })();

  /**
   * Get a specific marketplace image.
   *
   * @param request - The request {@link GetImageRequest}
   * @returns A Promise of GetImageResponse
   */
  getImage = request => this.client.fetch({
    method: 'GET',
    path: `/marketplace/v1/images/${validatePathParam('imageId', request.imageId)}`
  }, unmarshalGetImageResponse);
  listVersions = request => this.client.fetch({
    method: 'GET',
    path: `/marketplace/v1/images/${validatePathParam('imageId', request.imageId)}/versions`
  }, unmarshalListVersionsResponse);
  getVersion = request => this.client.fetch({
    method: 'GET',
    path: `/marketplace/v1/images/${validatePathParam('imageId', request.imageId)}/versions/${validatePathParam('versionId', request.versionId)}`
  }, unmarshalGetVersionResponse);
}

export { API };
