import { isJSONObject } from '../../../helpers/json.js';
import { unmarshalArrayOfObject, unmarshalDate } from '../../../helpers/marshalling.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
const unmarshalLocalImage = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'LocalImage' failed as data isn't a dictionary.`);
  }
  return {
    arch: data.arch,
    compatibleCommercialTypes: data.compatible_commercial_types,
    id: data.id,
    zone: data.zone
  };
};
const unmarshalOrganization = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Organization' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name
  };
};
const unmarshalVersion = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Version' failed as data isn't a dictionary.`);
  }
  return {
    creationDate: unmarshalDate(data.creation_date),
    id: data.id,
    localImages: unmarshalArrayOfObject(data.local_images, unmarshalLocalImage),
    modificationDate: unmarshalDate(data.modification_date),
    name: data.name
  };
};
const unmarshalImage = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Image' failed as data isn't a dictionary.`);
  }
  return {
    categories: data.categories,
    creationDate: unmarshalDate(data.creation_date),
    currentPublicVersion: data.current_public_version,
    description: data.description,
    id: data.id,
    label: data.label,
    logo: data.logo,
    modificationDate: unmarshalDate(data.modification_date),
    name: data.name,
    organization: data.organization ? unmarshalOrganization(data.organization) : undefined,
    validUntil: unmarshalDate(data.valid_until),
    versions: unmarshalArrayOfObject(data.versions, unmarshalVersion)
  };
};
const unmarshalGetImageResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetImageResponse' failed as data isn't a dictionary.`);
  }
  return {
    image: data.image ? unmarshalImage(data.image) : undefined
  };
};
const unmarshalGetVersionResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetVersionResponse' failed as data isn't a dictionary.`);
  }
  return {
    version: data.version ? unmarshalVersion(data.version) : undefined
  };
};
const unmarshalListImagesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListImagesResponse' failed as data isn't a dictionary.`);
  }
  return {
    images: unmarshalArrayOfObject(data.images, unmarshalImage),
    totalCount: data.total_count
  };
};
const unmarshalListVersionsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListVersionsResponse' failed as data isn't a dictionary.`);
  }
  return {
    totalCount: data.total_count,
    versions: unmarshalArrayOfObject(data.versions, unmarshalVersion)
  };
};

export { unmarshalGetImageResponse, unmarshalGetVersionResponse, unmarshalListImagesResponse, unmarshalListVersionsResponse };
